/*
* Sende Fernschreibzeichen und gebe empfangene Daten an Computer
* Sende vom Computer vorgegebene Zeichen ans Bluetoothe aus
* P Ping
* R  Run, nächstes Zeichen
 */
 
//Variablen zuweisen
#define LED 13        // Interne Anzeige Master-Slave vorhanden
char ch_Fs;
 
//Bluetooth Einstellungen
char ch_Zeichen;     // In dieser Variable wird ein Zeichen gespeichert
#define rxPin 11     // virtueller RX-Pin des Moduls zur Kommunikation mit dem HC-05
#define txPin 12     // virtueller TX-Pin des Moduls zur Kommunikation mit dem HC-05

#include <SoftwareSerial.h>
SoftwareSerial HC05(txPin, rxPin);

void setup()
{  
  HC05.begin(38400);        // Sende zum Fernschreiber
  Serial.begin(9600);       // Textübergabe
    
  //Warte auf Slave Modul
  digitalWrite(LED, 0);
  // Warte auf PC
  while (Serial.available() == -1)
  {
    // warten
  }
    do
   {
      delay(1000);                // warte 1 Sekunde
      HC05.print("P");
      ch_Zeichen = HC05.read();
   }while (ch_Zeichen != 'P');    // mindestens 1 Durchlauf der Schleife
  digitalWrite(LED, 1);
}

void loop()
{
   ch_Zeichen = HC05.read();      // Zeichen vom Slave, wenn nichts kommt steht er hier erstmal
    
    if (ch_Zeichen != -1)         // ch_Zeichen != 0xff Error
    {
      if (ch_Zeichen == 'R')
      {
        Serial.print(ch_Zeichen);
      }
    }                             // Zeichen vom Slave Empfangen
                                  // Zeichen vom PC an Slave senden
    ch_Fs = Serial.read();      // Zeichen vom PC
    if (ch_Fs != -1)            // ch_Fs != 0xff Error
    {
      if (ch_Fs < 0x20)         // alle Zeichen kleiner 0x20
      {
        HC05.print(ch_Fs);
      }                         // Ausgabe Fs Zeichen auf Slave - Fs
      else if ((ch_Fs == '1') | (ch_Fs == '5') | (ch_Fs == '7'))
      {
        HC05.print(ch_Fs);
      }                          // Übertragungsgeschwindigkeit      
    } // Empfange Zeichen vom PC, sende zum Slave
}    // loop

