/*
 * Row-Daten auf Fs-Schnittstelle ausgeben
 * Bereitschaft senden Fs Zeichen gesendet
 */

// Definieren der Variablen

//Bluetooth Einstellungen
char ch_Zeichen;   // In dieser Variable wird ein Zeichen gespeichert
#define rxPin 11   // virtueller RX-Pin des Moduls zur Kommunikation mit dem HC-05
#define txPin 12   // virtueller TX-Pin des Moduls zur Kommunikation mit dem HC-05

#define FsLine 3   // Sende TTY/Sende LED Blau

#define LED50 6    // Grün 50 Bd
#define LED75 7    // Gelb 75 Bd
#define LED100 8   // Rot 100 Bd

byte baud = 20;    // Standard 50 Bd
byte counter = 7;  // Für Schleife Do-While

#include <SoftwareSerial.h>
SoftwareSerial HC05(txPin, rxPin);

void setup() 
{  
  HC05.begin(38400);
   
  pinMode(FsLine, OUTPUT);    // Linien-Strom-Ausgabe
  pinMode(LED50, OUTPUT);     // Bd Anzeigen
  pinMode(LED75, OUTPUT);
  pinMode(LED100, OUTPUT);

  digitalWrite(LED50, 1);      // 50 Bd Standard
  
  //Warte bis Bereitschaft empfangen wurde
  digitalWrite(FsLine, 0);     // keine Bluetooth Verbindung
  while (ch_Zeichen != 'P')
  { 
    ch_Zeichen = HC05.read();
  }
  HC05.print("P");                 // sende Rückantwort
  digitalWrite(FsLine, 1);         // Verbindung steht, Empfangsbereit
}

void loop()
{
    ch_Zeichen = HC05.read();      // Zeichen vom Master, wenn nichts kommt steht er hier erstmal
    if (ch_Zeichen != -1)
    {
      if (ch_Zeichen < 0x20)       // 5 Bit Zeichen
      {
        ch_Zeichen <<= 1;           // Start ist bit 0, 1-5 Fs Zeichen, 5 und 7 Stoppschritt; Shift setzt bit 0 = 0
        ch_Zeichen |= 0b11000000;   // Maskierung: bit 1 - 5  sind die 5 Informationsschritte, 6 u. 7 werden auf "1" gesetzt
        counter = 7;                // 8 bit, die Stopp-Zeit des 8ten bit sind die Laufzeit des Programms
        do                          // Schneller als for(byte counter = 0; counter < 8; counter++)??
        {
          digitalWrite(FsLine, ch_Zeichen & 0x01);    // LED Frontseite ist parallel mit Optokoppler
          ch_Zeichen >>= 1;
          delay(baud);
          counter--;
        } while( counter > 0);
        HC05.print("R");            // Run - weiter
      }                             // ch_Zeichn < 0x20
      else if (ch_Zeichen == '1')
      {
        baud = 10;
        digitalWrite(LED50, 0);
        digitalWrite(LED75, 0);
        digitalWrite(LED100, 1);
      }
      else if (ch_Zeichen == '5')
      {
        baud = 20;
        digitalWrite(LED50, 1);
        digitalWrite(LED75, 0);
        digitalWrite(LED100, 0);
      }
      else if (ch_Zeichen == '7')
      {
        baud = 13;
        digitalWrite(LED50, 0);
        digitalWrite(LED75, 1);
        digitalWrite(LED100, 0);
      }
    } // if Error COM
}
