/*
 * Fernschreiber - Slave Initialisierung
 * Der Jumper muss auf AT stehen 
 * Meine Adresse Slave:  +ADDR: MAC-ADRESSE EINTRAGEN
 * Meine Adresse Master: +ADDR: MAC-ADRESSE EINTRAGEN
 * Arduino-NANO
 */

// Variablen zuweisen
String Text = "";  // In diesem String werden Texte zwischengespeichert
char Zeichen;      // In dieser Variable werden Zeichen zwischengespeichert
#define rxPin 11   // Virtueller RX-Pin des Moduls zur Kommunikation mit dem HC-05
#define txPin 12   // Virtueller TX-Pin des Moduls zur Kommunikation mit dem HC-05

#include <SoftwareSerial.h>
SoftwareSerial HC05(txPin, rxPin);

  
void setup() {
  Serial.begin(57600);     // Definieren der Baudrate für die integrierte serielle Schnittstelle
  HC05.begin(38400);       // Definieren der Baudrate für die sofware-simulierte serielle Schnittstelle
  // Initialisieren
  Serial.println("Initialisiere..."); 
  Serial.println();
  Serial.println("Konfiguriere HC-05 Modul:"); 
  Serial.println();
  // Reset HC-05 -> Slave mode, Baudrate 38400, Passwort:????, Device-Name: "Fernschreiber"
  Text = auslesen("AT+ORGL");
  Serial.println(Text);
  if (!Text.startsWith("OK")) {
    Serial.println("Fehler!");
    Serial.println("Steht der Jumper auf AT?");
    Serial.println("Sind alle Bluetooth-Verbindungen zum Modul getrennt?");
    Serial.println("Wechsle in den COM-Modus...");
    Serial.println();
    return;
  }
  
  // Lösche alle Devices aus der Pair-Liste
  Text = auslesen("AT+RMAAD");
  Serial.println(Text);
  if (!Text.startsWith("OK"))
  {
    Serial.println("Fehler!");
    while(1);     
  }
  
  // Setze Bluetooth-Name auf "Fernschreiber"
  Text = auslesen("AT+NAME=Fernschreiber");
  Serial.println(Text);
  if (!Text.startsWith("OK")) 
  {
    Serial.println("Fehler!");
    while(1);     
  }

  // Modul neustarten und eventuelle Verbindungen resetten
  Text = auslesen("AT+RESET");
  Serial.println(Text);
  if (!Text.startsWith("OK"))
  {
    Serial.println("Fehler!");
    while(1);     
  }
  delay(1000);  //So ein Reset dauert seine Zeit...

  // Bricht alle Verbindungen ab und macht das Modul in der Bluetooth-Umgebung sichtbar
  Text = auslesen("AT+INIT");
  Serial.println(Text);
  Text = auslesen("AT+DISC");
  Serial.println(Text);
  Text = auslesen("AT+ADDR?");
  Serial.println(Text);
  Serial.println("Das Modul ist jetzt bereit, bitte den Jumper jetzt auf COM stecken und die Datei Fernschreiber-Slave.ino auf den Chip uebertragen");
}

String auslesen(String Befehl)
{
  char Zeichen;                             // Jedes empfangene Zeichen kommt kurzzeitig in diese Variable.
  String result = "";
  Serial.println(Befehl);                   // Schreibe den übergebenen String auf den seriellen Monitor
  HC05.println(Befehl);                     // Sende den übergebenen String an das Modul
  delay(500);
  while(HC05.available() > 0)               // So lange etwas empfangen wird, durchlaufe die Schleife.
  {
    Zeichen = HC05.read();                  // Speichere das empfangene Zeichen in der Variablen "Zeichen".
    result.concat(Zeichen);                 // Speichere die Antwort des Moduls
  }  
  return result;                            // Übergebe die Rückantwort des Moduls
}

void loop()
{
  // nichts passiert hier

}
